// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from automatika_ros_sugar:msg/ComponentStatus.idl
// generated code does not contain a copyright notice

#include "automatika_ros_sugar/msg/detail/component_status__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_automatika_ros_sugar
const rosidl_type_hash_t *
automatika_ros_sugar__msg__ComponentStatus__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x28, 0x71, 0x4b, 0x08, 0xbd, 0x3c, 0x60, 0x66,
      0x28, 0xe7, 0xa6, 0x97, 0xd0, 0xd4, 0x99, 0xcb,
      0xe3, 0x33, 0x2d, 0xf4, 0x48, 0xbe, 0x1f, 0x49,
      0xca, 0x22, 0x63, 0x42, 0xc5, 0x87, 0xf4, 0x7d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char automatika_ros_sugar__msg__ComponentStatus__TYPE_NAME[] = "automatika_ros_sugar/msg/ComponentStatus";

// Define type names, field names, and default values
static char automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__status[] = "status";
static char automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__msg[] = "msg";
static char automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_topics[] = "src_topics";
static char automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_components[] = "src_components";
static char automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_algorithms[] = "src_algorithms";

static rosidl_runtime_c__type_description__Field automatika_ros_sugar__msg__ComponentStatus__FIELDS[] = {
  {
    {automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__status, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__msg, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_topics, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_components, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automatika_ros_sugar__msg__ComponentStatus__FIELD_NAME__src_algorithms, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
automatika_ros_sugar__msg__ComponentStatus__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {automatika_ros_sugar__msg__ComponentStatus__TYPE_NAME, 40, 40},
      {automatika_ros_sugar__msg__ComponentStatus__FIELDS, 5, 5},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "uint8 STATUS_HEALTHY=0   # COMPONENT IS RUNNING AND HEALTHY\n"
  "\n"
  "uint8 STATUS_FAILURE_ALGORITHM_LEVEL=1   # ERROR IN EXECUTING THE ALGORITHM/PLUGIN WITHIN THE COMPONENT\n"
  "\n"
  "uint8 STATUS_FAILURE_COMPONENT_LEVEL=2      # ERROR OR FAILURE IN THE COMPONENT LEVEL\n"
  "\n"
  "uint8 STATUS_FAILURE_SYSTEM_LEVEL=3     # ERROR IN COMPONENT EXECUTION DUE TO EXTERNAL FACTORS (SYSTEM LEVEL)\n"
  "\n"
  "uint8 STATUS_GENERAL_FAILURE=4\n"
  "\n"
  "uint8 status\n"
  "string msg\n"
  "\n"
  "string[] src_topics        # Registers names of the input topic provoking failure in case of system level error\n"
  "\n"
  "string[] src_components    # Registers names of the component provoking failure in case of system level error and component level error (self)\n"
  "\n"
  "string[] src_algorithms       # Registers names of the algorithm provoking failure in case of algorithmic level error";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
automatika_ros_sugar__msg__ComponentStatus__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {automatika_ros_sugar__msg__ComponentStatus__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 796, 796},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
automatika_ros_sugar__msg__ComponentStatus__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *automatika_ros_sugar__msg__ComponentStatus__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
